/* Copyright 2006 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef MESHSTEPABLES_HH
#define MESHSTEPABLES_HH

#include "Progress.hh"

namespace SharpConstruct
{
	class Mesh;

	class UpdateNormals : public Stepable
	{
	public:
		UpdateNormals( Mesh& );

		virtual double Progress() const;
		virtual const std::string Text() const;
		virtual bool Step();
	private:
		bool step_triangles_();
		bool step_quads_();
		bool step_vertices_();

		Mesh& mesh_;

		unsigned current_triangle_;
		unsigned current_quad_;
		unsigned current_vertex_;
	};

	class FinalizeCreation : public Stepable
	{
	public:
		FinalizeCreation( Mesh& );
		
		virtual double Progress() const;
		virtual const std::string Text() const;
		virtual bool Step();
	private:
		Mesh& mesh_;
		UpdateNormals update_normals_;

		bool step_one_done_, step_two_done_;
		bool done_;
	};
}

#endif
